<!DOCTYPE html>
<html lang="en">

<head>
    <title>Task 68</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>

    <div class="container">
        <h2 style="text-align: center;">Quản trị Voucher</h2>
        <div class="jumbotron container">
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="voucher-code">Mã Voucher</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="discount">Phần trăm giảm giá</label>
                </div>
                <div class="col-sm-9">
                    <input type="number" id="input-discount" name="discount" placeholder="Discount" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="note">Ghi chú</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="createDate">Ngày Tạo</label>
                </div>
                <div class="col-sm-9">
                    <input id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="updateDate">Ngày cập nhật</label>
                </div>
                <div class="col-sm-9">
                    <input id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
                </div>
            </div>
            <div class="row text-right">
                <div class="col-sm-12">
                    <button id="create-voucher" class="btn btn-success">Tạo mới</button>
                </div>
            </div>
        </div>

        <table class="table table-bordered table-striped table-hover" id="voucher-table">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Mã voucher</th>
                    <th>Phần trăm giảm giá</th>
                    <th>Ghi chú</th>
                    <th>Ngày tạo</th>
                    <th>Ngày cập nhật</th>
                    <th>Action</th>
                </tr>
        </table>

        <!-- Update voucher modal -->
        <div id="update-voucher-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Chi tiết voucher</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-voucher-code">Mã Voucher</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-ma-voucher" name="vouchercode" placeholder="Voucher Code" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-percent-discount">Phần trăm giảm giá</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-percent-discount" name="percentdiscount" placeholder="Phần trăm giảm giá" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-note">Ghi chú</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-note" name="note" placeholder="Ghi chú" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-create-date">Ngày tạo</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-create-date" name="createdate" placeholder="Ngày tạo" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-date">Ngày cập nhật</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-date" name="updatedate" placeholder="Ngày cập nhật" class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-success" id="btn-update-voucher">Update Voucher</button>
                        <button class="btn btn-danger" id="btn-update-cancel" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
        <!-- Delete confirm modal -->
        <div>
            <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">Confirm xóa voucher</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <label>Bạn có chắc chắn muốn xóa voucher này không?</label>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger" id="btn-confirm-delete-voucher">Xác nhận</button>
                            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                        </div>
                    </div>
                </div>
            </div>
</body>
<script>
    // khai báo biến mảng hằng số chứa danh sách tên các thuộc tính
    const gVOUCHER_COLS = ["id", "maVoucher", "phanTramGiamGia", "ghiChu", "ngayTao", "ngayCapNhat", "action"];
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gVOUCHER_ID_COL = 0;
    const gVOUCHER_MA_VOUCHER_COL = 1;
    const gVOUCHER_PHAN_TRAM_GIAM_GIA_COL = 2;
    const gVOUCHER_GHI_CHU_COL = 3;
    const gVOUCHER_NGAY_TAO_COL = 4;
    const gVOUCHER_NGAY_CAP_NHAT_COL = 5;
    const gVOUCHER_ACTION_COL = 6;
    // Đổ dữ liệu vào bàng và thực hiện nút Sửa (Edit), Xóa (Delete)
    $("#voucher-table").DataTable({
        columns: [{
            data: gVOUCHER_COLS[gVOUCHER_ID_COL]
        }, {
            data: gVOUCHER_COLS[gVOUCHER_MA_VOUCHER_COL]
        }, {
            data: gVOUCHER_COLS[gVOUCHER_PHAN_TRAM_GIAM_GIA_COL]
        }, {
            data: gVOUCHER_COLS[gVOUCHER_GHI_CHU_COL]
        }, {
            data: gVOUCHER_COLS[gVOUCHER_NGAY_TAO_COL]
        }, {
            data: gVOUCHER_COLS[gVOUCHER_NGAY_CAP_NHAT_COL]
        }, {
            data: gVOUCHER_COLS[gVOUCHER_ACTION_COL]
        }],
        columnDefs: [{
            // định nghĩa lại cột Action
            targets: gVOUCHER_ACTION_COL,
            className: "text-center",
            defaultContent: `
                <button class = "btn btn-primary btn-edit">Sửa</button>
                <button class = "btn btn-danger btn-delete" data-toggle='modal'>Xóa</button>
                `
        }, {
            targets: gVOUCHER_PHAN_TRAM_GIAM_GIA_COL,
            className: "text-center",
        }],
        autoWidth: false
    });

    $(document).ready(function() {
        var gListVouchers = [];
        var gVoucherId = "";
        onPageLoading();
        // gán sự kiện cho nút Create Voucher (trên modal)
        $("#create-voucher").on("click", function() {
            onBtnCreateVoucherClick();
        });
        // Gán sự kiện Update - Sửa 1 Voucher
        $("#voucher-table").on("click", ".btn-edit", function() {
            onBtnEditClick(this);
        });
        // gán sự kiện cho nút Update Voucher (trên modal)
        $("#btn-update-voucher").on("click", function() {
            onBtnUpdateVoucherClick();
        });
        // Gán sự kiện Delete - Xóa 1 Voucher
        $("#voucher-table").on("click", ".btn-delete", function() {
                onBtnDeleteClick(this);
            })
            // gán sự kiện cho nút Delete Voucher (trên modal)
        $("#btn-confirm-delete-voucher").on("click", function() {
                onBtnConfirmDeleteVoucherClick();
            })
            /** REGION 4: Common function: Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
        function onPageLoading() {
            "use strict";
            getAllVouchers();
            //1: Read/Load user to DataTable
            loadDataToVoucherTable(gListVouchers);
        }

        function getAllVouchers() {
            "use strict";
            $.ajax({
                url: "http://localhost:8080/voucher/all",
                type: "GET",
                dataType: 'json',
                async: false,
                success: function(responseObject) {
                    console.log(responseObject);
                    //lấy response trả về và gán cho biến gListVouchers
                    gListVouchers = responseObject;
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        // Load voucher vào DataTable
        function loadDataToVoucherTable(paramObjectVouchers) {
            console.log(paramObjectVouchers);
            var vTable = $("#voucher-table").DataTable();
            vTable.clear();
            vTable.rows.add(paramObjectVouchers);
            vTable.draw();
        }


        // Hàm xử lý sự kiện khi nút Thêm voucher được nhấn
        function onBtnCreateVoucherClick() {
            "use strict";
            //khai báo đối tượng chứa user data
            var vVoucherObj = {
                    maVoucher: "",
                    phanTramGiamGia: "",
                    ghiChu: "",
                    ngayTao: "",
                    //ngayCapNhat: ""
                }
                // B1: thu thập dữ liệu
            getVoucherDataCreate(vVoucherObj);
            //B2: Validate Insert
            var vIsVoucherValidate = validateInsertData(vVoucherObj);
            if (vIsVoucherValidate) {
                // B3: Insert user
                postVoucherApi(vVoucherObj);
                //B4: xử lý hiển thị
                //gọi API lấy danh sách user
                getAllVouchers();
                //load dữ liệu vào bảng
                loadDataToVoucherTable(gListVouchers);
                // xóa trắng dữ liệu trên modal
                resertCreateVoucherForm();
            }

        }
        // hàm thu thập dữ liệu để create voucher
        function getVoucherDataCreate(paramVoucherObj) {
            "use strict";
            paramVoucherObj.maVoucher = $("#input-voucher-code").val().trim();
            paramVoucherObj.phanTramGiamGia = $("#input-discount").val().trim();
            paramVoucherObj.ghiChu = $("#input-note").val().trim();
            paramVoucherObj.ngayTao = $("#input-createDate").val().trim();
            //paramVoucherObj.ngayCapNhat = $("#input-updateDate").val().trim();
        }

        function validateInsertData(paramVoucherObj) {
            "use strict";
            if (paramVoucherObj.maVoucher === "") {
                alert("Bạn cần nhập mã voucher!");
                return false;
            }
            if (paramVoucherObj.phanTramGiamGia === "") {
                alert("Bạn cần nhập phần trăm giảm giá!");
                return false;
            }
            if (paramVoucherObj.ghiChu === "") {
                alert("Bạn cần nhập ghi chú!");
                return false;
            }
            if (paramVoucherObj.ngayTao === "") {
                alert("Bạn cần nhập ngày tạo!");
                return false;
            }
            // if (paramVoucherObj.ngayCapNhat === "") {
            //     alert("Bạn cần nhập ngày cập nhật!");
            //     return false;
            // }
            return true;
        }

        function postVoucherApi(paramVoucherObj) {
            "use strict";
            $.ajax({
                async: false,
                url: "http://localhost:8080/voucher/create",
                type: "POST",
                data: JSON.stringify(paramVoucherObj),
                contentType: "application/json",
                success: function(res) {
                    console.log(res);
                    alert("Thêm voucher thành công!");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }

        function resertCreateVoucherForm() {
            "use strict";
            $("#input-voucher-code").val("");
            $("#input-discount").val("");
            $("#input-note").val("");
            $("#input-createDate").val("");
            $("#input-updateDate").val("");
        }

        function onBtnEditClick(paramButtonElement) {
            "use strict";
            console.log("Nút Sửa được nhấn!");
            var vRowClick = $(paramButtonElement).closest("tr"); // xác định tr chứa nút bấm được click
            var vTable = $("#voucher-table").DataTable(); // tạo biến truy xuất đến DataTable
            var vDataRow = vTable.row(vRowClick).data(); // Dữ liệu của hàng dữ liệu chứa nút bấm được click
            console.log("ID của voucher tương ứng = " + vDataRow.id);
            gVoucherId = vDataRow.id;
            $("#input-update-ma-voucher").val(vDataRow.maVoucher);
            $("#input-update-percent-discount").val(vDataRow.phanTramGiamGia);
            $("#input-update-note").val(vDataRow.ghiChu);
            $("#input-update-create-date").val(vDataRow.ngayTao);
            $("#input-update-date").val(vDataRow.ngayCapNhat);
            $("#update-voucher-modal").modal("show");
        }

        function onBtnUpdateVoucherClick() {
            "use strict";
            var vVoucherObj = {
                maVoucher: "",
                phanTramGiamGia: "",
                ghiChu: "",
                ngayTao: "",
                ngayCapNhat: ""
            }
            vVoucherObj.maVoucher = $("#input-update-ma-voucher").val().trim();
            vVoucherObj.phanTramGiamGia = $("#input-update-percent-discount").val().trim();
            vVoucherObj.ghiChu = $("#input-update-note").val().trim();
            vVoucherObj.ngayTao = $("#input-update-create-date").val().trim();
            vVoucherObj.ngayCapNhat = $("#input-update-date").val().trim();
            console.log(vVoucherObj);
            var vIsVoucherUpdateValidate = validateUpdateData(vVoucherObj);
            if (vIsVoucherUpdateValidate) {
                // B3: Update user
                putVoucherUpdateApi(vVoucherObj);
                //B4: xử lý hiển thị
                //gọi API lấy danh sách user
                getAllVouchers();
                //load dữ liệu vào bảng
                loadDataToVoucherTable(gListVouchers);
                // xóa trắng dữ liệu trên modal
                resertUpdateVoucherModal();
                // ẩn modal form
                $("#update-voucher-modal").modal("hide");
            }
        }

        function validateUpdateData(paramVoucherObj) {
            "use strict";
            if (paramVoucherObj.maVoucher === "") {
                alert("Bạn cần nhập mã Voucher!");
                return false;
            }
            if (paramVoucherObj.phanTramGiamGia === "") {
                alert("Bạn cần nhập phần trăm giảm giá!");
                return false;
            }
            if (paramVoucherObj.ghiChu === "") {
                alert("Bạn cần nhập ghi chú!");
                return false;
            }
            if (paramVoucherObj.ngayTao === "") {
                alert("Bạn cần nhập ngày tạo!");
                return false;
            }
            if (paramVoucherObj.ngayCapNhat === "") {
                alert("Bạn cần nhập ngày cập nhật!");
                return false;
            }
            return true;
        }

        function resertUpdateVoucherModal() {
            "use strict";
            $("#input-update-ma-voucher").val("");
            $("#input-update-percent-discount").val("");
            $("#input-update-note").val("");
            $("#input-update-create-date").val("");
            $("#input-update-date").val("");
        }

        function putVoucherUpdateApi(paramVoucherObj) {
            "use strict";
            $.ajax({
                async: false,
                url: "http://localhost:8080/voucher/update/" + gVoucherId,
                type: "PUT",
                data: JSON.stringify(paramVoucherObj),
                contentType: "application/json;charset=UTF-8",
                success: function(res) {
                    console.log(res);
                    alert("Update voucher thành công!");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }

        function onBtnDeleteClick(paramButtonElement) {
            "use strict";
            console.log("Nút Xóa được nhấn!");
            var vRowClick = $(paramButtonElement).closest("tr"); // xác định tr chứa nút bấm được click
            var vTable = $("#voucher-table").DataTable(); // tạo biến truy xuất đến DataTable
            var vDataRow = vTable.row(vRowClick).data(); // Dữ liệu của hàng dữ liệu chứa nút bấm được click
            console.log("ID của voucher tương ứng = " + vDataRow.id);
            $("#delete-confirm-modal").modal("show");
            gVoucherId = vDataRow.id;
        }

        function onBtnConfirmDeleteVoucherClick() {
            //khai báo đối tượng chưa voucher data (bỏ qua)
            //B1: Thu thập dữ liệu (bỏ qua)
            //B2: Validate delete data (bỏ qua)
            //B3: Delete voucher
            deleteVoucherApi(gVoucherId);
            alert("Xóa voucher thành công!");
            getAllVouchers();
            //load dữ liệu vào bảng
            loadDataToVoucherTable(gListVouchers);
            $("#delete-confirm-modal").modal("hide");

        }

        function deleteVoucherApi(paramVoucherId) {
            "use strict";
            $.ajax({
                async: false,
                url: "http://localhost:8080/voucher/delete/" + gVoucherId,
                type: "DELETE",
                data: 'json',
                success: function(res) {
                    console.log(res);
                    gListVouchers = res;
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }


    });
</script>

</html>
​